<?php

namespace {
    /*
     * Plugin Name: Atome Payment Gateway
     * Plugin URI: https://www.atome.sg
     * Description: Atome enables users to own the things you love now and pay later. The bill will be split into three equal instalments automatically. No hidden fees, 0% interest.
     * Author: Atome
     * Author URI: https://www.atome.sg
     * Version: 6.8.0
     * License: GNU Public License
     */
    require_once __DIR__ . '/vendor/autoload.php';
    \register_activation_hook(\ABSPATH . 'wp-content/plugins/aaclub_wc_plugin/aaclub_wc_plugin.php', [new \_PhpScoperAtome\Atome\Hook(), 'register_activation_hook']);
    \add_action('plugins_loaded', function () {
        if (!\defined('WOO_ATOME_PLUGIN_PATH')) {
            \define('WOO_ATOME_PLUGIN_PATH', \plugin_dir_path(__FILE__));
        }
        if (!\defined('WOO_ATOME_PLUGIN_URL')) {
            \define('WOO_ATOME_PLUGIN_URL', \plugin_dir_url(__FILE__));
        }
        (new \_PhpScoperAtome\Atome\Bootstrap())->boot();
    });
    ///**
    // * Custom function to declare compatibility with cart_checkout_blocks feature
    // */
    //function declare_atome_cart_checkout_blocks_compatibility()
    //{
    //    // Check if the required class exists
    //    if (class_exists('\Automattic\WooCommerce\Utilities\FeaturesUtil')) {
    //        // Declare compatibility for 'cart_checkout_blocks'
    //        \Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility('cart_checkout_blocks', __FILE__, true);
    //    }
    //}
    //
    //// Hook the custom function to the 'before_woocommerce_init' action
    //add_action('before_woocommerce_init', 'declare_atome_cart_checkout_blocks_compatibility');
    // Hook the custom function to the 'woocommerce_blocks_loaded' action
    \add_action('woocommerce_blocks_loaded', 'atome_register_order_approval_payment_method_type');
    /**
     * Custom function to register a payment method type
     * @internal
     */
    function atome_register_order_approval_payment_method_type()
    {
        // Check if the required class exists
        if (!\class_exists('Automattic\\WooCommerce\\Blocks\\Payments\\Integrations\\AbstractPaymentMethodType')) {
            return;
        }
        // Include the custom Blocks Checkout class
        require_once \plugin_dir_path(__FILE__) . 'includes/AtomeBlockGateway.php';
        // Hook the registration function to the 'woocommerce_blocks_payment_method_type_registration' action
        \add_action('woocommerce_blocks_payment_method_type_registration', function (\Automattic\WooCommerce\Blocks\Payments\PaymentMethodRegistry $payment_method_registry) {
            // Register an instance of My_Custom_Gateway_Blocks
            $payment_method_registry->register(new \_PhpScoperAtome\Atome\AtomeBlockGateway());
        });
    }
}
