<?php

namespace _PhpScoperAtome\Atome;

use Automattic\WooCommerce\Blocks\Payments\Integrations\AbstractPaymentMethodType;
/** @internal */
final class AtomeBlockGateway extends AbstractPaymentMethodType
{
    /**
     * @var AtomeGateway
     */
    private $gateway;
    protected $name = 'atome';
    // your payment gateway name
    public function initialize()
    {
        $this->settings = get_option('woocommerce_atome_settings', []);
        $this->gateway = new AtomeGateway();
    }
    public function is_active()
    {
        return $this->gateway->is_available();
    }
    public function get_payment_method_script_handles()
    {
        wp_register_script('atome-blocks-integration', plugin_dir_url(__FILE__) . 'Block/checkout.js', ['wc-blocks-registry', 'wc-settings', 'wp-element', 'wp-html-entities', 'wp-i18n'], null, \true);
        if (\function_exists('wp_set_script_translations')) {
            wp_set_script_translations('atome-blocks-integration');
        }
        return ['atome-blocks-integration'];
    }
    public function get_payment_method_data()
    {
        return ['title' => $this->gateway->title, 'description' => $this->gateway->getPlainDescription()];
    }
}
