<?php

namespace _PhpScoperAtome\Atome\Config;

/** @internal */
class Language
{
    use ErrorMessage;
    protected $translates = [];
    /**
     * @var Language
     */
    private static $instance;
    public function boot()
    {
        $this->setTranslates();
    }
    public static function instance()
    {
        if (\is_null(self::$instance)) {
            self::$instance = new self();
        }
        return self::$instance;
    }
    protected function setTranslates()
    {
        $language = Config::option('language');
        $localeTranslates = [];
        $localeConfig = Config::instance()->getLocaleConfig();
        if ($language !== 'en' && isset($localeConfig['language_file'][$language])) {
            $languageFileName = $localeConfig['language_file'][$language] ?? 'English';
            $path = WOO_ATOME_PLUGIN_PATH . '/i18n/languages/' . $languageFileName . '.php';
            if (\file_exists($path)) {
                $localeTranslates = (require $path);
            }
        }
        $englishTranslates = (require WOO_ATOME_PLUGIN_PATH . '/i18n/languages/English.php');
        $this->translates = \array_merge((array) $englishTranslates, (array) $localeTranslates);
    }
    public function get($keys)
    {
        if (\is_array($keys)) {
            $result = [];
            foreach ($keys as $v) {
                $result[$v] = $this->translates[$v] ?? $v;
            }
            return $result;
        }
        return $this->translates[$keys] ?? $keys;
    }
    public function trans($key, $values = [])
    {
        $values = \array_merge((array) Config::instance()->getLocaleConfig(), (array) $values);
        return \preg_replace_callback('/{{(\\w+?)}}/', function ($matches) use($values) {
            return $values[$matches[1]] ?? '';
        }, $this->get($key));
    }
}
