<?php

namespace _PhpScoperAtome\Atome\Enums;

use _PhpScoperAtome\Atome\Config\Config;
/** @internal */
final class Atome
{
    protected static $version = '6.8.0';
    protected static $baseURL = 'https://gateway.apaylater.com';
    protected static $icon = '/common/assets/svg/logo-payments.svg';
    const ID = 'atome';
    const TITLE = 'Atome';
    const PLUGIN_ENTRANCE = 'aaclub_wc_plugin/atome.php';
    const DESCRIPTION = 'Atome Payment Gateway';
    const SUPPORTS = [Support::PRODUCTS, Support::REFUNDS];
    const HAS_FIELDS = \false;
    const DEFAULT_CANCEL_TIMEOUT = 720;
    const MINIMUM_CANCEL_TIMEOUT = 10;
    const MAXIMUM_CANCEL_TIMEOUT = 720;
    const LEGACY_VERSION_ZIP_URL = 'https://gateway.apaylater.com/woocommerce/aaclub_wc_plugin.zip';
    const PRODUCTION_VERSION_ZIP_URL = 'https://atome-paylater-fe.s3-accelerate.amazonaws.com/merchant-plugins/production/woocommerce/v4/latest/aaclub_wc_plugin.zip';
    const STAGING_API_URL = 'https://api.apaylater.net/v1';
    const PRODUCTION_API_URL = 'https://api.apaylater.com/v1';
    const MINIMUM_WOOCOMERCE_VERSION = '4.0.0';
    const REMOTE_CONFIG_EXPIRE_SECONDS = 3600;
    const SENTRY_DSN = 'https://db6c497f7b724b45ba53ecfe161a1bdf@sentry.atomecorp.com/149';
    const PRODUCTION_BASE_URL = 'https://gateway.apaylater.com';
    const FORCE_UPGRADE_URL = '/plugins/wc/patch/6.8.0.json';
    const PLATFORM = 'WOOCOMMERCE';
    const STAGING_LOG_URL = 'https://app.apaylater.net/report?wordpress=1';
    const PRODUCTION_LOG_URL = 'https://fe-log.apaylater.com/report?wordpress=1';
    const STAGING_STATIC_FILE_URL = 'https://d3adhqenoxpdg2.cloudfront.net/merchant-plugins/staging/static';
    const PRODUCTION_STATIC_FILE_URL = 'https://atome-paylater-fe.s3-accelerate.amazonaws.com/merchant-plugins/production/static';
    public static function baseURL()
    {
        if (\strpos(self::$baseURL, '{BASE_URL}') === \false) {
            return self::$baseURL;
        }
        return self::PRODUCTION_BASE_URL;
    }
    public static function version()
    {
        if (\strpos(self::$version, '{VERSION}') === \false) {
            return self::$version;
        }
        $composer = \json_decode(\file_get_contents(\implode('', [__DIR__, \DIRECTORY_SEPARATOR, '..', \DIRECTORY_SEPARATOR, '..', \DIRECTORY_SEPARATOR, 'composer.json'])));
        return $composer->version ?: null;
    }
    public static function icon()
    {
        return self::staticFileDomain() . self::$icon;
    }
    public static function staticFileDomain()
    {
        $env = Config::option('api_environment');
        return $env === Environment::STAGING ? self::STAGING_STATIC_FILE_URL : self::PRODUCTION_STATIC_FILE_URL;
    }
    public static function getApiBaseUrl()
    {
        $apiBaseUrls = [Environment::STAGING => Atome::STAGING_API_URL, Environment::PRODUCTION => Atome::PRODUCTION_API_URL];
        $env = Config::option('api_environment');
        return isset($apiBaseUrls[$env]) ? $apiBaseUrls[$env] . '/' : Atome::PRODUCTION_API_URL;
    }
}
