<?php

namespace _PhpScoperAtome\Atome\Exceptions;

use _PhpScoperAtome\Atome\Config\Config;
use _PhpScoperAtome\Atome\Config\Language;
use Throwable;
/** @internal */
class MinimumSpeedException extends \Exception
{
    protected $code = -1012;
    public function __construct($message = "", $code = 0, Throwable $previous = null)
    {
        parent::__construct($message, $code, $previous);
        $this->message = $this->minimumSpendError();
    }
    public function minimumSpendError()
    {
        $localeInfo = Config::instance()->getLocaleConfig();
        $config_minimum_spend = Config::get('minimum_spend', 10);
        return \preg_replace_callback('/{{(\\w+?)}}/', function ($matches) use($localeInfo, $config_minimum_spend) {
            if ($matches[1] === 'minimum_spend') {
                return wc_price($config_minimum_spend);
            }
            return $localeInfo[$matches[1]] ?? '';
        }, Language::instance()->get('minimum_spend_error'));
    }
}
