<?php

namespace _PhpScoperAtome\Atome\Payment;

use _PhpScoperAtome\Atome\Enums\Atome;
/** @internal */
class Auth extends Payment
{
    protected $apiKey;
    protected $password;
    protected $country;
    protected $configuration;
    public function handle()
    {
        $this->response = wp_remote_post(Atome::getApiBaseUrl() . 'auth', ['method' => 'POST', 'headers' => \array_merge($this->getHeader(), ["Authorization" => $this->generateAuthorization($this->apiKey, $this->password)]), 'body' => \json_encode(['callbackUrl' => get_site_url() . '/?wc-api=LINK', 'countryCode' => \strtoupper($this->country), "platform" => "WOOCOMMERCE", 'pluginConfiguration' => $this->configuration ?: []])]);
        return $this;
    }
    /**
     * @param mixed $country
     * @return Auth
     */
    public function setCountry($country)
    {
        $this->country = \strtoupper($country);
        return $this;
    }
    /**
     * @param mixed $apiKey
     * @return Auth
     */
    public function setApiKey($apiKey)
    {
        $this->apiKey = $apiKey;
        return $this;
    }
    /**
     * @param mixed $password
     * @return Auth
     */
    public function setPassword($password)
    {
        $this->password = $password;
        return $this;
    }
    /**
     * @param mixed $configuration
     * @return Auth
     */
    public function setConfiguration($configuration)
    {
        $this->configuration = $configuration;
        return $this;
    }
}
