<?php

namespace _PhpScoperAtome\Atome\Payment;

use _PhpScoperAtome\Atome\Config\Config;
use _PhpScoperAtome\Atome\Enums\Atome;
/** @internal */
abstract class Payment
{
    protected $response;
    protected $isSuccess;
    public abstract function handle();
    public function isHTTPSuccess()
    {
        return !is_wp_error($this->response) && wp_remote_retrieve_response_code($this->response) === 200;
    }
    public function isCodeSuccess()
    {
        if ($this->isEmptyBody()) {
            return \false;
        }
        $body = $this->getBody();
        return isset($body['code']) && \strtoupper($body['code']) === 'SUCCESS';
    }
    public function isEmptyBody()
    {
        return empty($this->response['body']);
    }
    public function getBody($jsonDecode = \true)
    {
        if ($this->isEmptyBody()) {
            return null;
        }
        return $jsonDecode ? \json_decode($this->response['body'], \true) : $this->response['body'];
    }
    /**
     * @return mixed
     */
    public function getResponse()
    {
        return $this->response;
    }
    protected function getHeader()
    {
        return ['Authorization' => $this->generateAuthorization(Config::option('api_key'), Config::option('password')), 'Content-Type' => 'application/json', 'X-Version' => Atome::version(), 'X-Woocommerce-Version' => WC()->version, 'X-PHP-Version' => \phpversion()];
    }
    protected function generateAuthorization($apiKey, $password)
    {
        $apiKey = \trim($apiKey);
        $password = \trim($password);
        return 'basic' . \base64_encode("{$apiKey}:{$password}");
    }
}
