<?php

namespace _PhpScoperAtome\Atome\Payment;

use _PhpScoperAtome\Atome\Enums\Atome;
use _PhpScoperAtome\Atome\Services\Logger;
/** @internal */
class Result extends Payment
{
    public function handle()
    {
        $token = $_GET['token'] ?? '';
        $args = ['method' => 'GET', 'headers' => $this->getHeader()];
        $apiUrl = Atome::getApiBaseUrl() . 'payments/?token=' . $token;
        $response = wp_remote_get($apiUrl, $args);
        if (is_wp_error($response) || wp_remote_retrieve_response_code($response) !== 200) {
            Logger::instance()->error('result_handler query payment Response: ' . \json_encode($response));
            exit;
        }
        Logger::instance()->info('result_handler query payment Response: ' . \json_encode(['body' => $response['body'], 'response' => $response['response']]));
        $body = \json_decode($response['body'], \true);
        $order_id = $body['referenceId'];
        $order = wc_get_order($order_id);
        if (!$order) {
            Logger::instance()->error('result_handler query order empty, redirect to checkout.' . $order_id);
            wp_redirect(wc_get_checkout_url());
            exit;
        }
        Logger::instance()->info('result_handler query order success, redirect to thank you page.');
        if (wp_redirect($order->get_checkout_order_received_url())) {
            exit;
        }
    }
}
