<?php

namespace _PhpScoperAtome\Atome\Services;

use _PhpScoperAtome\Atome\Config\Config;
use _PhpScoperAtome\Atome\Enums\Atome;
/** @internal */
class Sentry
{
    /**
     * @var Config
     */
    private static $instance;
    public static function instance()
    {
        if (\is_null(self::$instance)) {
            self::$instance = new self();
        }
        return self::$instance;
    }
    public function boot()
    {
        \_PhpScoperAtome\Sentry\init(['dsn' => Atome::SENTRY_DSN, 'release' => Atome::version(), 'sample_rate' => 0.1, 'server_name' => isset($_SERVER['SERVER_NAME']) ? (string) $_SERVER['SERVER_NAME'] : 'NULL', 'default_integrations' => \false]);
        \_PhpScoperAtome\Sentry\configureScope(function (\_PhpScoperAtome\Sentry\State\Scope $scope) : void {
            $scope->setTag('atome.platform', Atome::PLATFORM);
        });
    }
    public function capture($exception)
    {
        if (Config::get('enable_send_errors') === 'yes') {
            \_PhpScoperAtome\Sentry\captureException($exception);
        }
    }
}
