<?php

namespace _PhpScoperAtome\Atome;

use _PhpScoperAtome\_PhpScoper9c38ab071f60\Atome\Services\Logger;
use _PhpScoperAtome\Atome\Services\LogRequest;
/** @internal */
class UninstallFeedback
{
    public function boot()
    {
        add_action('admin_footer', array(new UninstallFeedback(), 'deactivate_scripts'));
        add_action('wp_ajax_atome_submit_uninstall_reason', array(new UninstallFeedback(), "send_uninstall_reason"));
    }
    protected function get_uninstall_reasons()
    {
        $reasons = array(array('id' => 'no-country-support', 'text' => __('Doesn\'t have support in my country.', 'aaclub_wc_plugin')), array('id' => 'temporary-debug', 'text' => __('Temporary deactivation for debugging.', 'aaclub_wc_plugin')), array('id' => 'excessive-cancellation-rates', 'text' => __('Excessive payment cancellation rates.', 'aaclub_wc_plugin')), array('id' => 'need-more-installments', 'text' => __('I would like more installments.', 'aaclub_wc_plugin'), 'type' => 'textarea', 'placeholder' => __('What\'s your preferred number of installments?', 'aaclub_wc_plugin')), array('id' => 'feature-not-found', 'text' => __('Couldn’t find a feature I am looking for.', 'aaclub_wc_plugin'), 'type' => 'textarea', 'placeholder' => __('Could you tell us about it?', 'aaclub_wc_plugin')), array('id' => 'other', 'text' => __('Other', 'aaclub_wc_plugin'), 'type' => 'textarea', 'placeholder' => __('Could you tell us a bit more?', 'aaclub_wc_plugin')));
        return $reasons;
    }
    public function deactivate_scripts()
    {
        global $pagenow;
        if ('plugins.php' != $pagenow) {
            return;
        }
        $reasons = $this->get_uninstall_reasons();
        ?>
        <div class="atome-modal" id="atome-feedback-modal">
            <div class="atome-modal-wrap">
                <div class="atome-modal-header">
                    <h3><?php 
        _e('If you have a moment, please let us know why you are deactivating:', 'aaclub_wc_plugin');
        ?></h3>
                </div>
                <div class="atome-modal-body">
                    <ul class="reasons">
                        <?php 
        foreach ($reasons as $reason) {
            ?>
                            <li <?php 
            if (isset($reason['type'])) {
                ?> data-type="<?php 
                echo esc_attr($reason['type']);
                ?>" <?php 
            }
            if (isset($reason['placeholder'])) {
                ?> data-placeholder="<?php 
                echo esc_attr($reason['placeholder']);
                ?>" <?php 
            }
            ?> >
                                <label><input type="radio" name="selected-reason"
                                              value="<?php 
            echo $reason['id'];
            ?>"> <?php 
            echo $reason['text'];
            ?>
                                </label>
                            </li>
                            <?php 
        }
        ?>
                    </ul>
                    <div class="wt-uninstall-feedback-privacy-policy">
                        <?php 
        _e("We do not collect any personal data when you submit this form. It's your feedback that we value.", "aaclub_wc_plugin");
        ?>
                        <a href="https://www.atome.sg/privacy-policy"
                           target="_blank"><?php 
        _e('Privacy Policy', 'aaclub_wc_plugin');
        ?></a>
                    </div>
                </div>
                <div class="atome-modal-footer">

                    <a class="button-primary"
                       href="https://help.atome.sg/hc/en-gb"
                       target="_blank">
                        <span class="dashicons dashicons-external" style="margin-top:3px;"></span>
                        <?php 
        _e('Go to support', 'aaclub_wc_plugin');
        ?></a>
                    <button class="button-primary atome-model-submit"><?php 
        _e('Submit & Deactivate', 'aaclub_wc_plugin');
        ?></button>
                    <button class="button-secondary atome-model-cancel"><?php 
        _e('Cancel', 'aaclub_wc_plugin');
        ?></button>
                    <a href="#"
                       class="dont-bother-me"><?php 
        _e('I rather wouldn\'t say', 'aaclub_wc_plugin');
        ?></a>
                </div>
            </div>
        </div>

        <style type="text/css">
            .atome-modal {
                position: fixed;
                z-index: 99999;
                top: 0;
                right: 0;
                bottom: 0;
                left: 0;
                background: rgba(0, 0, 0, 0.5);
                display: none;
            }

            .atome-modal.modal-active {
                display: block;
            }

            .atome-modal-wrap {
                width: 50%;
                position: relative;
                margin: 10% auto;
                background: #fff;
            }

            .atome-modal-header {
                border-bottom: 1px solid #eee;
                padding: 8px 20px;
            }

            .atome-modal-header h3 {
                line-height: 150%;
                margin: 0;
            }

            .atome-modal-body {
                padding: 5px 20px 20px 20px;
            }

            .atome-modal-body .input-text, .atome-modal-body textarea {
                width: 75%;
            }

            .atome-modal-body .reason-input {
                margin-top: 5px;
                margin-left: 20px;
            }

            .atome-modal-footer {
                border-top: 1px solid #eee;
                padding: 12px 20px;
                text-align: left;
            }

            .reviewlink, .support_link, .info-class {
                padding: 10px 0px 0px 35px !important;
                font-size: 15px;
            }

            .review-and-deactivate, .reach-via-support {
                padding: 5px;
            }

            .wt-uninstall-feedback-privacy-policy {
                text-align: left;
                font-size: 12px;
                color: #aaa;
                line-height: 14px;
                margin-top: 20px;
                font-style: italic;
            }

            .wt-uninstall-feedback-privacy-policy a {
                font-size: 11px;
                color: #4b9cc3;
                text-decoration-color: #99c3d7;
            }
        </style>
        <script type="text/javascript">
            (function (jQuery) {
                var modal = jQuery('#atome-feedback-modal');
                var deactivateLink = '';
                jQuery('#deactivate-atome-payment-gateway').on('click', function (e) {
                    e.preventDefault();
                    modal.addClass('modal-active');
                    deactivateLink = jQuery(this).attr('href');
                    modal.find('a.dont-bother-me').attr('href', deactivateLink).css('float', 'right');
                });

                jQuery('#atome-feedback-modal').on('click', 'a.review-and-deactivate', function (e) {
                    e.preventDefault();
                    window.location.href = deactivateLink;
                });

                modal.on('click', 'button.atome-model-cancel', function (e) {
                    e.preventDefault();
                    modal.removeClass('modal-active');
                });
                modal.on('click', 'input[type="radio"]', function () {
                    var parent = jQuery(this).parents('li:first');
                    modal.find('.reason-block').remove();
                    var inputType = parent.data('type'),
                        inputPlaceholder = parent.data('placeholder');

                    if (jQuery('.reviewlink').length) {
                        jQuery('.reviewlink').hide();
                    }
                    if (jQuery('.info-class').length) {
                        jQuery('.info-class').hide();
                    }
                    if (jQuery('.reason-input').length) {
                        jQuery('.reason-input').hide();
                    }

                    if ('reviewhtml' === inputType) {
                        var reasonInputHtml = '<div class="reviewlink"><?php 
        _e('Deactivate and ', 'express-checkout-paypal-payment-gateway-for-woocommerce');
        ?> <a href="#" target="_blank" class="review-and-deactivate"><?php 
        _e('leave a review', 'express-checkout-paypal-payment-gateway-for-woocommerce');
        ?> <span class="xa-ehpypl-rating-link"> &#9733;&#9733;&#9733;&#9733;&#9733; </span></a></div>';
                    } else if ('info' === inputType) {
                        var reasonInputHtml = '<div class="info-class">' + inputPlaceholder + '</div>';
                    } else if ('text' === inputType || 'textarea' === inputType) {
                        var reasonInputHtml = '<div class="reason-input reason-block">' + (('text' === inputType) ? '<input type="text" class="input-text" size="40" />' : '<textarea rows="5" cols="45"></textarea>') + '</div>';
                    }
                    if (inputType !== '') {
                        parent.append(jQuery(reasonInputHtml));
                        parent.find('input, textarea').attr('placeholder', inputPlaceholder).focus();
                    }
                });

                modal.on('click', 'button.atome-model-submit', function (e) {
                    e.preventDefault();
                    var button = jQuery(this);
                    if (button.hasClass('disabled')) {
                        return;
                    }
                    var $radio = jQuery('input[type="radio"]:checked', modal);
                    var $selected_reason = $radio.parents('li:first'),
                        $input = $selected_reason.find('textarea, input[type="text"]');
                    $reason_info = (0 !== $input.length) ? $input.val().trim() : '';
                    $reason_id = (0 === $radio.length) ? 'none' : $radio.val()

                    jQuery.ajax({
                        url: ajaxurl,
                        type: 'POST',
                        data: {
                            action: 'atome_submit_uninstall_reason',
                            reason_id: $reason_id,
                            reason_info: $reason_info
                        },
                        beforeSend: function () {
                            button.addClass('disabled');
                            button.text('Processing...');
                        },
                        complete: function () {
                            window.location.href = deactivateLink;
                        }
                    });
                });
            }(jQuery));
        </script>
        <?php 
    }
    public function send_uninstall_reason()
    {
        if (!isset($_POST['reason_id'])) {
            wp_send_json_error();
        }
        $logRequest = new LogRequest();
        $logRequest->uninstall(sanitize_text_field($_POST['reason_id']), isset($_REQUEST['reason_info']) ? \trim(\stripslashes($_REQUEST['reason_info'])) : '');
        wp_send_json_success();
    }
}
