<?php

namespace _PhpScoperAtome\Http\Factory\Guzzle;

use _PhpScoperAtome\GuzzleHttp\Psr7\ServerRequest;
use _PhpScoperAtome\Psr\Http\Message\ServerRequestFactoryInterface;
use _PhpScoperAtome\Psr\Http\Message\ServerRequestInterface;
/** @internal */
class ServerRequestFactory implements ServerRequestFactoryInterface
{
    public function createServerRequest(string $method, $uri, array $serverParams = []) : ServerRequestInterface
    {
        if (empty($method)) {
            if (!empty($serverParams['REQUEST_METHOD'])) {
                $method = $serverParams['REQUEST_METHOD'];
            } else {
                throw new \InvalidArgumentException('Cannot determine HTTP method');
            }
        }
        return new ServerRequest($method, $uri, [], null, '1.1', $serverParams);
    }
}
