<?php

namespace _PhpScoperAtome\Http\Discovery\Strategy;

use _PhpScoperAtome\Psr\Http\Message\RequestFactoryInterface;
use _PhpScoperAtome\Psr\Http\Message\ResponseFactoryInterface;
use _PhpScoperAtome\Psr\Http\Message\ServerRequestFactoryInterface;
use _PhpScoperAtome\Psr\Http\Message\StreamFactoryInterface;
use _PhpScoperAtome\Psr\Http\Message\UploadedFileFactoryInterface;
use _PhpScoperAtome\Psr\Http\Message\UriFactoryInterface;
/**
 * @internal
 *
 * @author Tobias Nyholm <tobias.nyholm@gmail.com>
 *
 * Don't miss updating src/Composer/Plugin.php when adding a new supported class.
 */
final class CommonPsr17ClassesStrategy implements DiscoveryStrategy
{
    /**
     * @var array
     */
    private static $classes = [RequestFactoryInterface::class => ['_PhpScoperAtome\\Phalcon\\Http\\Message\\RequestFactory', '_PhpScoperAtome\\Nyholm\\Psr7\\Factory\\Psr17Factory', '_PhpScoperAtome\\GuzzleHttp\\Psr7\\HttpFactory', '_PhpScoperAtome\\Http\\Factory\\Diactoros\\RequestFactory', '_PhpScoperAtome\\Http\\Factory\\Guzzle\\RequestFactory', '_PhpScoperAtome\\Http\\Factory\\Slim\\RequestFactory', '_PhpScoperAtome\\Laminas\\Diactoros\\RequestFactory', '_PhpScoperAtome\\Slim\\Psr7\\Factory\\RequestFactory'], ResponseFactoryInterface::class => ['_PhpScoperAtome\\Phalcon\\Http\\Message\\ResponseFactory', '_PhpScoperAtome\\Nyholm\\Psr7\\Factory\\Psr17Factory', '_PhpScoperAtome\\GuzzleHttp\\Psr7\\HttpFactory', '_PhpScoperAtome\\Http\\Factory\\Diactoros\\ResponseFactory', '_PhpScoperAtome\\Http\\Factory\\Guzzle\\ResponseFactory', '_PhpScoperAtome\\Http\\Factory\\Slim\\ResponseFactory', '_PhpScoperAtome\\Laminas\\Diactoros\\ResponseFactory', '_PhpScoperAtome\\Slim\\Psr7\\Factory\\ResponseFactory'], ServerRequestFactoryInterface::class => ['_PhpScoperAtome\\Phalcon\\Http\\Message\\ServerRequestFactory', '_PhpScoperAtome\\Nyholm\\Psr7\\Factory\\Psr17Factory', '_PhpScoperAtome\\GuzzleHttp\\Psr7\\HttpFactory', '_PhpScoperAtome\\Http\\Factory\\Diactoros\\ServerRequestFactory', '_PhpScoperAtome\\Http\\Factory\\Guzzle\\ServerRequestFactory', '_PhpScoperAtome\\Http\\Factory\\Slim\\ServerRequestFactory', '_PhpScoperAtome\\Laminas\\Diactoros\\ServerRequestFactory', '_PhpScoperAtome\\Slim\\Psr7\\Factory\\ServerRequestFactory'], StreamFactoryInterface::class => ['_PhpScoperAtome\\Phalcon\\Http\\Message\\StreamFactory', '_PhpScoperAtome\\Nyholm\\Psr7\\Factory\\Psr17Factory', '_PhpScoperAtome\\GuzzleHttp\\Psr7\\HttpFactory', '_PhpScoperAtome\\Http\\Factory\\Diactoros\\StreamFactory', '_PhpScoperAtome\\Http\\Factory\\Guzzle\\StreamFactory', '_PhpScoperAtome\\Http\\Factory\\Slim\\StreamFactory', '_PhpScoperAtome\\Laminas\\Diactoros\\StreamFactory', '_PhpScoperAtome\\Slim\\Psr7\\Factory\\StreamFactory'], UploadedFileFactoryInterface::class => ['_PhpScoperAtome\\Phalcon\\Http\\Message\\UploadedFileFactory', '_PhpScoperAtome\\Nyholm\\Psr7\\Factory\\Psr17Factory', '_PhpScoperAtome\\GuzzleHttp\\Psr7\\HttpFactory', '_PhpScoperAtome\\Http\\Factory\\Diactoros\\UploadedFileFactory', '_PhpScoperAtome\\Http\\Factory\\Guzzle\\UploadedFileFactory', '_PhpScoperAtome\\Http\\Factory\\Slim\\UploadedFileFactory', '_PhpScoperAtome\\Laminas\\Diactoros\\UploadedFileFactory', '_PhpScoperAtome\\Slim\\Psr7\\Factory\\UploadedFileFactory'], UriFactoryInterface::class => ['_PhpScoperAtome\\Phalcon\\Http\\Message\\UriFactory', '_PhpScoperAtome\\Nyholm\\Psr7\\Factory\\Psr17Factory', '_PhpScoperAtome\\GuzzleHttp\\Psr7\\HttpFactory', '_PhpScoperAtome\\Http\\Factory\\Diactoros\\UriFactory', '_PhpScoperAtome\\Http\\Factory\\Guzzle\\UriFactory', '_PhpScoperAtome\\Http\\Factory\\Slim\\UriFactory', '_PhpScoperAtome\\Laminas\\Diactoros\\UriFactory', '_PhpScoperAtome\\Slim\\Psr7\\Factory\\UriFactory']];
    /**
     * {@inheritdoc}
     */
    public static function getCandidates($type)
    {
        $candidates = [];
        if (isset(self::$classes[$type])) {
            foreach (self::$classes[$type] as $class) {
                $candidates[] = ['class' => $class, 'condition' => [$class]];
            }
        }
        return $candidates;
    }
}
