<?php

namespace _PhpScoperAtome\Http\Client\Exception;

use _PhpScoperAtome\Psr\Http\Client\NetworkExceptionInterface as PsrNetworkException;
use _PhpScoperAtome\Psr\Http\Message\RequestInterface;
/**
 * Thrown when the request cannot be completed because of network issues.
 *
 * There is no response object as this exception is thrown when no response has been received.
 *
 * @author Márk Sági-Kazár <mark.sagikazar@gmail.com>
 * @internal
 */
class NetworkException extends TransferException implements PsrNetworkException
{
    use RequestAwareTrait;
    /**
     * @param string $message
     */
    public function __construct($message, RequestInterface $request, \Exception $previous = null)
    {
        $this->setRequest($request);
        parent::__construct($message, 0, $previous);
    }
}
