<?php

declare (strict_types=1);
namespace _PhpScoperAtome\Sentry\HttpClient;

use _PhpScoperAtome\Http\Client\HttpAsyncClient as HttpAsyncClientInterface;
use _PhpScoperAtome\Sentry\Options;
/**
 * This interface defines a contract for classes willing to serve as factories
 * for the HTTP client.
 * @internal
 */
interface HttpClientFactoryInterface
{
    /**
     * Create HTTP Client wrapped with configured plugins.
     *
     * @param Options $options The client options
     */
    public function create(Options $options) : HttpAsyncClientInterface;
}
