<?php

declare (strict_types=1);
namespace _PhpScoperAtome\Sentry\Serializer;

use _PhpScoperAtome\Sentry\Event;
/**
 * This interface defines the contract for the classes willing to serialize an
 * event object to a format suitable for sending over the wire to Sentry.
 * @internal
 */
interface PayloadSerializerInterface
{
    /**
     * Serializes the given event object into a string.
     *
     * @param Event $event The event object
     */
    public function serialize(Event $event) : string;
}
