<?php

declare (strict_types=1);
namespace _PhpScoperAtome\Sentry\Transport;

use _PhpScoperAtome\GuzzleHttp\Promise\FulfilledPromise;
use _PhpScoperAtome\GuzzleHttp\Promise\PromiseInterface;
use _PhpScoperAtome\Sentry\Event;
use _PhpScoperAtome\Sentry\Response;
use _PhpScoperAtome\Sentry\ResponseStatus;
/**
 * This transport fakes the sending of events by just ignoring them.
 *
 * @author Stefano Arlandini <sarlandini@alice.it>
 * @internal
 */
final class NullTransport implements TransportInterface
{
    /**
     * {@inheritdoc}
     */
    public function send(Event $event) : PromiseInterface
    {
        return new FulfilledPromise(new Response(ResponseStatus::skipped(), $event));
    }
    /**
     * {@inheritdoc}
     */
    public function close(?int $timeout = null) : PromiseInterface
    {
        return new FulfilledPromise(\true);
    }
}
